Imports System
Imports System.Collections
Imports System.Reflection
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Drawing
Imports System.Drawing.Imaging


Public Class BitmapHandler
    Implements IDisposable

    'The list of bitmap files that have been created in the Temp folder
    Dim files As New ArrayList()

    Sub Dispose() Implements IDisposable.Dispose
        CleanFiles()
    End Sub

    'Creates a file on disk from the specified bitmap resource
    Function CreateFileFromResourceBitmap(ByVal bitmapName As String) As String
        Dim thisAssembly As [Assembly]
        Dim byteStream As Stream
        Dim image As Bitmap
        Dim filePath As String

        'Initial Values
        filePath = System.IO.Path.GetTempFileName()

        'Obtain the bitmap
        thisAssembly = System.Reflection.Assembly.GetAssembly(Me.GetType())
        byteStream = thisAssembly.GetManifestResourceStream(bitmapName)
        image = New Bitmap(byteStream)


        Try
            'Try to save the image to disk
            image.Save(filePath)
            CreateFileFromResourceBitmap = filePath
            files.Add(filePath)
        Catch e As Exception
            'If it failed to save, return an empy path string
            CreateFileFromResourceBitmap = ""
            Return ""
        Finally
            'Clean things up 
            image.Dispose()
            thisAssembly = Nothing
            byteStream.Close()
            byteStream = Nothing
        End Try
    End Function

    'Removes the image files from your temp folder
    Function CleanFiles() As Boolean
        Dim curFile As String

        While files.Count > 0
            Try
                'Try to delete the file 
                curFile = files.Item(0)
                System.IO.File.Delete(curFile)
                files.RemoveAt(0)
            Catch e As Exception
                files.RemoveAt(0)
            End Try
        End While
    End Function
End Class


